-- 历练
Lua_ExperienceWindow = class("Lua_ExperienceWindow", Lua_Window)
function Lua_ExperienceWindow:ctor()
    self:superCall("ctor");

    self.layer = MainWinDefine.MAIN_WINDOW_LAYER;
    self.windowName = "Lua_ExperienceWindow";
    self.isFullSizeWin = true;
    self.showWinBg = true;
    self.winBgPath = "/images/scene/ui_yj_bj_001.png";
    self.winBgPosY = 100;
    self.openSound = "bgm_yijie";
    self.closeSound = nil;
    self:addPreLoadRes("/images/scene/ui_yj_bj_001.png", Lua_LoadFileType.IMG);
    self:addPreLoadRes("/images/scene/ui_yj_bj_003.png", Lua_LoadFileType.IMG);
    self:addPreLoadRes("/effects/uiEffects/ui_yj_beijing", Lua_LoadFileType.UNITY3D);
end

function Lua_ExperienceWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    if bActive then
        AudioManager.instance:play(self.openSound);
    end
end

function Lua_ExperienceWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.bgEff1 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_yj_beijing", "ui_yj_beijing01", 0, -800);
    self.bgEff1.siblingIndex = 0;
    self.bgEff1.anchorValue = 1;

    self.bgEff2 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_yj_beijing", "ui_yj_beijing02", 0, -800);
    self.bgEff2.anchorValue = 1;

    self.showImg = UICreate.createImage(self.content, "/images/scene/ui_yj_bj_003.png", 0, 100, 0, 0);
    self.showImg.anchorValue = 1;
    self.showImg.pivotValue = 1;

    self.bgEff3 = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_yj_beijing", "ui_yj_beijing03", 0, -800);
    self.bgEff3.anchorValue = 1;
    
    self.itemList = Array();
    local arr = DataCenter.funcPlayUtil:getPlayArrByType(Lua_FuncPlayDefine.TYPE_EXPERIENCE);
    local vo;
    local item;
    for i = 1, arr:getSize() do
        vo = arr[i];
        item = Lua_ExperienceItem.new(self.content);
        item.contentName = "Lua_ExperienceItem"..vo.id;
        item:setRectAnchor(1);
        item:setLocation(vo.showPos[1], vo.showPos[2]);
        item:setData(vo);
        self.itemList:add(item);
    end

    self:addLuaEvent("FIGHTPLAY_ENTER", self, self.checkIsFighting);
    self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.checkIsFighting);
end

function Lua_ExperienceWindow:dispose()
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList:clear();
        self.itemList = nil;
    end
    self:superCall("dispose");
end

function Lua_ExperienceWindow:showWin(param)
    self:superCall("showWin", param);
    Lua_MsgUtil.callFunc("UPDATE_MAIN_MENU", Lua_MenuViewDefine.MEBULIST_MAIN);
end

function Lua_ExperienceWindow:checkIsFighting(templateId)
    for i = 1, self.itemList:getSize() do
        self.itemList[i]:checkIsFighting();
    end
end




















Lua_ExperienceItem = class("Lua_ExperienceItem", Lua_DisplayObject)
function Lua_ExperienceItem:ctor(p)
    self:superCall("ctor", p, "ExperienceItem_skin");
end

function Lua_ExperienceItem:buildShowItem()
    self:superCall("buildShowItem");
    self.clickArea:addClickFuntion(self, self.onClick);
    self.nameBg:addClickFuntion(self, self.onClick);
    self.bg_1:setEnable(false);
    self.bg_2:setEnable(false);
    self.infoText:setEnable(false);
    self.timeText:setEnable(false);

    self:addLuaEvent("UPDATE_EXPERIENCEITEM_INFO", self, self.showDisplay); -- 关卡信息返回
end

function Lua_ExperienceItem:dispose()
    self:stopTimer();
    if self.fightEff then
        self.fightEff:dispose();
        self.fightEff = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_ExperienceItem:setData(data)
    self.data = data;
    self:setRectSize(data.iconWidth, data.iconHeight);
    self.clickArea:SetDimensions(data.iconWidth, data.iconHeight);
    self.nameText.text = data.name;
    LuaUtil.setObjPos(self.nameObject, data.namePos[1], data.namePos[2], 0);
    self:setRedPoint(data.redPointId, data.redPos[1], data.redPos[2]);
    self:checkIsFighting();
    self:showDisplay();
end

function Lua_ExperienceItem:showDisplay()
    local vo = DataCenter.funcPathUtil:getFuncPathVo(self.data.pathId);
    if vo and vo.openState then
        self.nameBg:setAltas("func_entrance_atlas", "ui_yj_window_001");
        self.nameText.colorStr = Lua_ColorDefine.transColorStr("FFF0D6");
        if self.data.id == Lua_FuncPlayDefine.KUNXU_HOLYLAND then
            local kunXuHolyLandData = DataCenter.kunXuHolyLandData;
            if kunXuHolyLandData.curStageVo ~= nil then
                self.infoText:setEnable(true);
                self.timeText:setEnable(true);
                self.bg_1:setEnable(true);
                self.bg_2:setEnable(true);

                self.infoText.text = LanUtil.formateStr(620000, kunXuHolyLandData.passLevelNum, kunXuHolyLandData.curStageVo.levelCount);
                self.timeTick = kunXuHolyLandData.closeTick;
                if self.timeTick > 0 then
                    self:startTimer();
                    self:onTimer();
                else
                    self.timeText.text = nil;
                end
            end
        end
    else
        self.nameBg:setAltas("func_entrance_atlas", "ui_yj_window_011");
        self.nameText.colorStr = Lua_ColorDefine.transColorStr("A5A5A5");
        self.infoText:setEnable(false);
        self.timeText:setEnable(false);
        self.bg_1:setEnable(false);
        self.bg_2:setEnable(false);
        self:stopTimer();
    end
end

function Lua_ExperienceItem:setRedPoint(id, posX, posY)
    if strIsNullOrEmpty(id) then
        if self.redPointIcon ~= nil then
            self.redPointIcon:changeRedPoint(nil);
        end
    else
        if self.redPointIcon == nil then
            self.redPointIcon = Lua_RedPointIcon.new(self.nameObject);
        end
        self.redPointIcon:setLocation(posX, posY);
        self.redPointIcon:changeRedPoint(id);
    end
end

function Lua_ExperienceItem:checkIsFighting()
    local recordId = 0;
    if self.data ~= nil and self.data.templateList ~= nil then
        local list = self.data.templateList;
        for i = 1, #list do
            recordId = DataCenter.fightData:getRecordIdByTemplateId(list[i]);
            if recordId > 0 then
                break;
            end
        end
    end
    self:showFightEff(recordId > 0);
end

function Lua_ExperienceItem:showFightEff(value)
    if value then
        if self.fightEff == nil then
            self.fightEff = UICreate.createUIEffect(self.nameObject, "/effects/uiEffects/ui_ty_zdbs_0101", "ui_ty_zdbs_0101", 0, 45)
        end
        self.fightEff:setEnable(true)
    else
        if self.fightEff then
            self.fightEff:setEnable(false)
        end
    end
end

function Lua_ExperienceItem:onClick(go)
    if self.data == nil then
        return;
    end

    local checkIsFighting = true;
    if self.data.id == Lua_FuncPlayDefine.ARENA_ENTRANCE or self.data.id == Lua_FuncPlayDefine.UNCHARTED_ADVENTURE then
        checkIsFighting = false;
    elseif self.data.id == Lua_FuncPlayDefine.LIGHT_TOWER and DataCenter.climbTowerData:checkCampTowerIsOpen() then
        checkIsFighting = false;
    end
    DataCenter.funcPathUtil:gotoFunction(self.data.pathId, false, checkIsFighting)
end

function Lua_ExperienceItem:startTimer()
    if self.bTimer ~= true then
        self.bTimer = true;
        Lua_CommonUtil.addTimer("Lua_ExperienceItem_Time", 1, self, self.onTimer);
    end
end

function Lua_ExperienceItem:stopTimer()
    if self.bTimer == true then
        self.bTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onTimer);
    end
end

function Lua_ExperienceItem:onTimer()
    if self.data.id == Lua_FuncPlayDefine.KUNXU_HOLYLAND then
        local remainTime = self.timeTick - DataCenter.roleData.serverTime;
        if remainTime > 0 then
            self.timeText.text = Lua_TimeTransform.transSeconds1(remainTime);            
        else
            self.timeText.text = nil;
        end
    else
        self:stopTimer();
    end
end