Lua_HomeWindow = class("Lua_HomeWindow", Lua_Window);
function Lua_HomeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HomeWindow";
	-- self.skinName = "HomeWindow_skin"
	self.layer = MainWinDefine.MAIN_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/scene/ui_j_bj_001.jpg";
	self.openSound = "bgm_zhucheng";
	self.closeSound = nil;

	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_HomeWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	if bActive then
		AudioManager.instance:play(self.openSound);
	end
end

function Lua_HomeWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg.anchorValue = 4;
	self.winBg.pivotValue = 4;

    self.itemArr = Array();
    local arr = DataCenter.funcPlayUtil:getPlayArrByType(Lua_FuncPlayDefine.TYPE_HOME);
    local vo;
    local item;
    for i = 1, arr:getSize() do
        vo = arr[i];
        item = Lua_HomeItem.new(self.content);
        item.contentName = "Lua_HomeItem"..vo.id;
        item:setLocation(vo.showPos[1], vo.showPos[2]);
        item:setData(vo);
        self.itemArr:add(item);
    end
end

function Lua_HomeWindow:dispose()
	if self.itemArr then
		self.itemArr:dispose();
		self.itemArr:clear();
		self.itemArr = nil;
	end
	self:superCall("dispose");
end




















Lua_HomeItem = class("Lua_HomeItem", Lua_DisplayObject)
function Lua_HomeItem:ctor(p)
	self:superCall("ctor", p, "HomeItem_skin");
end

function Lua_HomeItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon:addClickFuntion(self, self.onClick);
	self.nameBg:addClickFuntion(self, self.onClick);
end

function Lua_HomeItem:dispose()
	if self.redPoint then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HomeItem:setData(data)
	self.data = data;

	self.icon:setAltas(data.iconAtlas, data.iconSprite);
	self.icon:SetDimensions(data.iconWidth, data.iconHeight);
	LuaUtil.setObjPos(self.nameObject, data.namePos[1], data.namePos[2], 0);
	self.nameText.text = data.name;

	if data.id == 50004 then
		self.nameBg:setRot(0, 0, 90);
		self.nameText:SetDimensions(40, 40);
		self.nameText.horizontalOverflowValue = 0;
		self.nameText.verticalOverflowValue = 1;
	else
		self.nameBg:setRot(0, 0, 0);
		self.nameText:SetDimensions(100, 40);
		self.nameText.horizontalOverflowValue = 1;
		self.nameText.verticalOverflowValue = 0;
	end

	self:setRedPoint(data.redPointId, data.redPos[1], data.redPos[2]);
end

function Lua_HomeItem:setRedPoint(id, posX, posY)
	if strIsNullOrEmpty(id) then
		if self.redPoint then
			self.redPoint:changeRedPoint(nil);
		end
	else
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.nameObject);
		end
		self.redPoint:setLocation(posX, posY, 0);
		self.redPoint:changeRedPoint(id);
	end
end

function Lua_HomeItem:onClick(go)
	if self.data == nil then
		return;
	end
	DataCenter.funcPathUtil:gotoFunction(self.data.pathId);
end