-- 秘境探险
checkRequire("Lua_FuncEntranceItem");
Lua_UnchartedAdventureWindow = class("Lua_UnchartedAdventureWindow", Lua_Window);
function Lua_UnchartedAdventureWindow:ctor()
    self:superCall("ctor");

    self.layer = MainWinDefine.MAIN_MENU_LAYER;
    self.windowName = "Lua_UnchartedAdventureWindow";
    self.isFullSizeWin = true;
    self.isFullPaving = true;
    self.showWinBg = true;
    self.winBgPath = "/images/scene/ui_yj_bj_002.jpg";
    self.showTitle = true;
    self.titleAtlas = "func_entrance_atlas";
    self.titleSprite = "ui_yj_title_01";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
end

function Lua_UnchartedAdventureWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.titleName.anchorValue = 1;
    self.titleName.pivotValue = 1;
    self.titleName:setLocation(21.5, -72, 0);
    self:createBackBtn(72.5, 75);

    self.itemList = Lua_DragList.new(self.content, 680, 1080 + self.adaptHeight, Lua_AxisDefine.Vertical);
    self.itemList:setLocation(0, -25, 0);
    self.itemList.tweenId = 2002;
    self.itemList:setListCell(Lua_FuncEntranceItem, 680, 323, 1);
    self.itemList:setCellSpacing(0, 20);

    local arr = DataCenter.funcPlayUtil:getPlayArrByType(Lua_FuncPlayDefine.TYPE_UNCHARTED_ADVENTURE);
    self.itemList:setArrayData(arr);
    self.itemList.canDrag = not self.itemList.isTheEnd

    self:addLuaEvent("FIGHTPLAY_ENTER", self, self.checkIsFighting);
    self:addLuaEvent("FIGHTPLAY_COMPLETE", self, self.checkIsFighting);
    self:addLuaEvent("EQUIP_COPY_INFO", self, self.updateEquipCopy);--寂灭岛次数更新
end

function Lua_UnchartedAdventureWindow:onBackBtnClick()
    DataCenter.funcPathUtil:gotoFunction(1047, true);
end

function Lua_UnchartedAdventureWindow:dispose()
    if self.itemList ~= nil then
        self.itemList:dispose();
        self.itemList = nil;
    end
    self:superCall("dispose");
end

function Lua_UnchartedAdventureWindow:onScreenResize()
    self:superCall("onScreenResize");
    self.itemList:setContentRect(680, 1080 + self.adaptHeight);
end

function Lua_UnchartedAdventureWindow:updateEquipCopy()
    local showList = self.itemList.showList;
    for i = 1, showList:getSize() do
        showList[i]:showEquipCopyInfo();
        showList[i]:checkIsOpened();
    end
end

function Lua_UnchartedAdventureWindow:checkIsFighting(templateId)
    local showList = self.itemList.showList;
    for i = 1, showList:getSize() do
        showList[i]:checkIsFighting();
    end
end